/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */
import{LitElement as b,html as n,nothing as c}from"lit";import{property as p,state as m,customElement as v}from"lit/decorators.js";import{live as y}from"lit/directives/live.js";import"@typo3/backend/element/spinner-element.js";import"@typo3/backend/element/icon-element.js";import $ from"@typo3/backend/notification.js";import u from"@typo3/backend/utility/dom-helper.js";import S from"@typo3/core/ajax/ajax-request.js";import{copyToClipboard as T}from"@typo3/backend/copy-to-clipboard.js";import{lll as h}from"@typo3/core/lit-helper.js";import{markdown as k}from"@typo3/core/directive/markdown.js";import"@typo3/backend/settings/editor/editable-setting.js";import"@typo3/backend/settings/type/bool.js";import"@typo3/backend/settings/type/int.js";import"@typo3/backend/settings/type/number.js";import"@typo3/backend/settings/type/string.js";import"@typo3/backend/settings/type/stringlist.js";var d=function(g,i,t,e){var s=arguments.length,r=s<3?i:e===null?e=Object.getOwnPropertyDescriptor(i,t):e,o;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")r=Reflect.decorate(g,i,t,e);else for(var a=g.length-1;a>=0;a--)(o=g[a])&&(r=(s<3?o(r):s>3?o(i,t,r):o(i,t))||r);return s>3&&r&&Object.defineProperty(i,t,r),r};let l=class extends b{constructor(){super(...arguments),this.customFormData={},this.debug=!1,this.searchTerm="",this.activeCategory="",this.visibleCategories={},this.observer=null}createRenderRoot(){return this}adjustNavigationSize(){const i=u.scrollableParent(this),t=this.querySelector(".settings-navigation-inner");if(t){const e=i.getBoundingClientRect(),s=this.querySelector(".settings-search").getBoundingClientRect(),r=this.querySelector(".settings-navigation").getBoundingClientRect();t.style.maxHeight=`${e.bottom-Math.max(0,e.bottom-r.bottom)-s.bottom}px`}}firstUpdated(){u.scrollableParent(this).addEventListener("scroll",()=>{this.adjustNavigationSize()}),this.observer=new IntersectionObserver(t=>{t.forEach(r=>{const o=r.target.dataset.key;this.visibleCategories[o]=r.isIntersecting});const e=r=>r.reduce((o,a)=>[...o,a.key,...e(a.categories)],[]),s=e(this.categories).filter(r=>this.visibleCategories[r])[0]||"";s&&(this.activeCategory=s)},{root:document.querySelector(".module"),threshold:.1,rootMargin:`-${getComputedStyle(document.querySelector(".settings-navigation-inner")).getPropertyValue("top")} 0px 0px 0px`})}updated(i){if([...this.renderRoot.querySelectorAll(".settings-category")].map(t=>this.observer?.observe(t)),this.adjustNavigationSize(),i.has("activeCategory")){const t=this.querySelector(".settings-navigation-inner"),e=this.querySelector(".settings-navigation-item.active");if(t&&e){const s=t.scrollTop,r=t.getBoundingClientRect().height,o=e.getBoundingClientRect().height,a=e.offsetTop>=s,f=e.offsetTop+o<=s+r;a?f||this.querySelector(".settings-navigation-inner").scrollTo({top:Math.max(0,e.offsetTop+o),behavior:"auto"}):this.querySelector(".settings-navigation-inner").scrollTo({top:Math.max(0,e.offsetTop-o),behavior:"auto"})}}}renderCategoryTree(i,t){const e=u.isRTL()?"actions-chevron-left":"actions-chevron-right";return n`<ul data-level=${t}>${i.map(s=>n`<li ?hidden=${s.__hidden}><button type=button @click=${r=>{r.preventDefault(),this.selectCategory(s)}} class="settings-navigation-item ${this.activeCategory===s.key?"active":""}"><span class=settings-navigation-item-icon> <typo3-backend-icon identifier=${s.icon?s.icon:e} size=small></typo3-backend-icon> </span><span class=settings-navigation-item-label>${s.label}</span></button> ${s.categories.length===0?c:n`${this.renderCategoryTree(s.categories,t+1)}`}</li>`)}</ul>`}renderSettings(i,t){return i.map(e=>n`<div class=settings-category-list data-key=${e.key}><div class=settings-category data-key=${e.key} ?hidden=${e.__hidden}>${this.renderHeadline(Math.min(t+1,6),`category-headline-${e.key}`,e.icon,n`${e.label}`)}<div class=settings-category-description>${e.description?k(e.description,"minimal"):c}</div></div>${e.settings.map(s=>n`<typo3-backend-editable-setting ?hidden=${s.__hidden} .setting=${s} .dumpuri=${this.dumpUrl} ?debug=${this.debug}></typo3-backend-editable-setting>`)}</div>${e.categories.length===0?c:n`${this.renderSettings(e.categories,t+1)}`}`)}renderHeadline(i,t,e,s){switch(i){case 1:return n`<h1 class=settings-category-headline id=${t}>${e?n`<typo3-backend-icon identifier=${e}></typo3-backend-icon>`:c}${s}</h1>`;case 2:return n`<h2 class=settings-category-headline id=${t}>${e?n`<typo3-backend-icon identifier=${e}></typo3-backend-icon>`:c}${s}</h2>`;case 3:return n`<h3 class=settings-category-headline id=${t}>${e?n`<typo3-backend-icon identifier=${e}></typo3-backend-icon>`:c}${s}</h3>`;case 4:return n`<h4 class=settings-category-headline id=${t}>${e?n`<typo3-backend-icon identifier=${e}></typo3-backend-icon>`:c}${s}</h4>`;case 5:return n`<h5 class=settings-category-headline id=${t}>${e?n`<typo3-backend-icon identifier=${e}></typo3-backend-icon>`:c}${s}</h5>`;case 6:return n`<h6 class=settings-category-headline id=${t}>${e?n`<typo3-backend-icon identifier=${e}></typo3-backend-icon>`:c}${s}</h6>`;default:throw new Error(`Invalid header level: ${i}`)}}selectCategory(i){const t=`#category-headline-${i.key}`,e=this.renderRoot.querySelector(t.replaceAll(".","\\.")),s=u.scrollableParent(this),r=this.renderRoot.querySelector(".settings-search").offsetHeight,o=parseInt(window.getComputedStyle(this.renderRoot.querySelector(".settings-body-inner")).paddingTop,10),a=e.offsetTop-r-o;s.scrollTo({top:a,behavior:"smooth"}),this.activeCategory=i.key}async onSubmit(i){const t=i.target;if(i.submitter?.value==="export"){i.preventDefault();const e=new FormData(t),r=await(await new S(this.dumpUrl).post(e)).resolve();typeof r.yaml=="string"?T(r.yaml):(console.warn("Value can not be copied to clipboard.",typeof r.yaml),$.error(h("copyToClipboard.error")))}}async onSearch(i){i.preventDefault(),this.searchTerm=i.currentTarget.value}render(){const i=this.filterCategories(),t=i.filter(e=>!e.__hidden).length>0;return n`<form class=settings-container id=sitesettings_form name=sitesettings_form action=${this.actionUrl} method=post @submit=${e=>this.onSubmit(e)}>${Object.entries(this.customFormData).map(([e,s])=>n`<input type=hidden name=${e} value=${s}>`)}<div class=settings><div class=settings-search><label for=settings-search class=visually-hidden>${h("edit.searchTermVisuallyHiddenLabel")}</label> <input type=search id=settings-search class=form-control placeholder=${h("edit.searchTermPlaceholder")} .value=${y(this.searchTerm)} @change=${e=>this.onSearch(e)} @input=${e=>this.onSearch(e)}></div><div class=settings-navigation ?hidden=${!t}><div class=settings-navigation-inner @transitionend=${()=>this.adjustNavigationSize()}>${this.renderCategoryTree(i??[],1)}</div></div><div class=settings-body ?hidden=${!t}><div class=settings-body-inner>${this.renderSettings(i??[],1)}</div></div></div>${t?c:n`<div class="callout callout-info mt-3"><div class=callout-icon><span class=icon-emphasized> <typo3-backend-icon identifier=actions-info size=small></typo3-backend-icon> </span></div><div class=callout-content><div class=callout-title>${h("edit.search.noResultsTitle")}</div><div class=callout-body><p>${h("edit.search.noResultsMessage")}</p><button type=button class="btn btn-default" @click=${()=>this.searchTerm=""}>${h("edit.search.noResultsResetButtonLabel")}</button></div></div></div>`}</form>`}filterCategories(i=null){return i??=this.categories,i.map(t=>{const e=this.filterSettings(t.settings),s=this.filterCategories(t.categories),r=e.filter(a=>!a.__hidden).length>0,o=s.filter(a=>!a.__hidden).length>0;return{...t,settings:e,categories:s,__hidden:!r&&!o}})}filterSettings(i){return i.map(t=>({...t,__hidden:!(this.matchesSearchTerm(t.definition.key)||this.matchesSearchTerm(t.definition.label)||this.matchesSearchTerm(t.definition.description??"")||this.valueMatchesSearchTerm(t.value)||t.definition.tags.filter(e=>this.matchesSearchTerm(e)).length>0)}))}matchesSearchTerm(i){return this.searchTerm===""?!0:this.matchesSubstring(i,this.searchTerm)}valueMatchesSearchTerm(i){return typeof i=="string"?this.matchesSearchTerm(i):Array.isArray(i)?i.filter(t=>typeof t=="string"&&this.matchesSearchTerm(t)).length>0:!1}matchesSubstring(i,t){return i.toLowerCase().includes(t.toLowerCase())}};d([p({type:Array})],l.prototype,"categories",void 0),d([p({type:String,attribute:"action-url"})],l.prototype,"actionUrl",void 0),d([p({type:String,attribute:"dump-url"})],l.prototype,"dumpUrl",void 0),d([p({type:Object,attribute:"custom-form-data"})],l.prototype,"customFormData",void 0),d([p({type:Boolean})],l.prototype,"debug",void 0),d([m()],l.prototype,"searchTerm",void 0),d([m()],l.prototype,"activeCategory",void 0),l=d([v("typo3-backend-settings-editor")],l);export{l as SettingsEditorElement};
